/*
 *  The graphical definition element of deltaFSD
 *  engine.c - function instantiation and the core exeution engine 
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */	
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */


# include <stdio.h>
# include <stdlib.h>//for malloc
# include <stdarg.h>
# include <gtk/gtk.h>

# include "engine.h"
# include "gutils.h"

void process_vars (funs f)
{// work through each of outputs to force changes
	if (f->counts == f->outs) /* anti loop test */
		for (f->counts = 0; f->counts < f->outs; f->counts++)
			process_var (&(f->frstout[f->counts]));
	else printf ("Recursive loop - cannot reprocess %s\n", f->funct->fname);
}

void process_func (funs f)
{
	(*f->funct->func) (f); 	// execute the function
	process_vars (f); // force consequential changes
}

void process_var (varo curo)
{
funp curf;
	if (curo->current_value == curo->next_value) 
		return;	/* no change - nothing to do */
	curo->current_value = curo->next_value; /* update the value */
	// then work through each of its dependant functions to force recalculation
	for (curf = curo->frstf; curf != NULL; curf = curf->next)
		process_func (curf->depfun);
}
//
void add_funcio (funs fs)
{
int counter;
	if (0 < fs->outs) fs->frstout = malloc (fs->outs * sizeof(*(fs->frstout)));
	else fs->frstout = NULL;
	for (counter = 0; counter < fs->outs; counter++)
		{	/* initialize the variable */
		fs->frstout[counter].next_value = fs->frstout[counter].current_value = 0.0;
		fs->frstout[counter].frstf = NULL; /* no functions yet */
		new_srcstub (fs->bp, counter, &(fs->frstout[counter])); /* create the corresponding stub */
		}
//	
	if (0 < fs->ins) fs->frstin = malloc (fs->ins * sizeof(*(fs->frstin)));
	else fs->frstin = NULL; 	
	for (counter = 0; counter < fs->ins; counter++)
		{	
		fs->frstin[counter].ovarb = NULL; /* no source variable yet */
		new_dststub (fs->bp, counter, &(fs->frstin[counter])); /* create the corresponding stub */
		}
	fs->counts = fs->outs; /* allow first run execution */
}
funs function_insert (futs funct, boxp bp)
{	/* create a new instance of the indicated function */
funs fp;
	fp = malloc (sizeof (*fp));	/* create the function structure*/
	fp->funct = funct;
	fp->frstout = 0;		/* no outputs - till we make them */
	fp->frstin = 0;		/* no inputs - till we link them */
	fp->ins = funct->ins; /* this avoids some complication with modules */
	fp->outs = funct->outs;
	fp->bp = bp;		/* join the function to the box */
	bp->fp = fp; 		/* an the box back to this function */
	bp->text1 = funct->fname; /* may be overridden */
	add_funcio (fp); /* add the inputs and outputs */
	return fp;
}







