
/*
 *	The graphical definition element of deltaFSD
 *	fconst.c - the various components of the const function
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */


# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include "function.h"
# include "main.h"
# include "deletion.h"
# include "engine.h"



void init_const (futs f);
void instance_const (funs fp);
void popup_const (boxp bp);
void create_const (xmlNodePtr node, funs fp);
void write_const (xmlNodePtr node, boxp bp);
void remove_const (funs fp);


struct Fx const_functions = {
	init_const,			/* when the const function type is created */
	instance_const,		/* create instance from UI */
	popup_const,		/* right click on hotspot */
	create_const,		/* create instance from file */
	write_const,		/* generate text version of configuration */
	remove_const,		/* any per instance clean up */
	"Enter details for constant value"
	};



typedef struct {
	funs fp;
	GtkWidget	*dwindow; /* the setup dialog window */
	GtkWidget	*name_entry;
	GtkWidget	*value_entry;
	std_buffer	text1;
	std_buffer	text2;
	std_buffer	text3;
	} instance_data;
	


/* Constant function */
void Constant (funs fp) 
# define IDP ((instance_data *)fp->bp->idata)
{
	Out(0) = atof(IDP->text3);
}






void make_const (boxp bp)
# define IDP ((instance_data *)bp->idata)
{ /* the const start code goes here */
	bp->text2 = IDP->text2;
	bp->text3 = IDP->text3;
{
}

	update_and_redraw (bp->fp); /* always recalc and redraw */
}

void const_button_press (boxp bp)
# define IDP ((instance_data *)bp->idata)
{
gchar *entry_text;
	entry_text = gtk_entry_get_text(GTK_ENTRY(IDP->name_entry));
	strncpy (IDP->text2, entry_text, sizeof(IDP->text2));
	entry_text = gtk_entry_get_text(GTK_ENTRY(IDP->value_entry));
	strncpy (IDP->text3, entry_text, sizeof(IDP->text3));
	gtk_widget_destroy (IDP->dwindow);
	make_const (bp);
}

void init_const (futs f)
{
}

void setup_const_dialog (boxp bp)
# define IDP ((instance_data *)bp->idata)
{
	IDP->dwindow = create_entry_vbox (const_button_press, (GtkObject*)bp);
	text_info ((GTK_DIALOG (IDP->dwindow)->vbox), bp->fp->funct->funcext->describe);
	IDP->name_entry = prompt_entry ((GTK_DIALOG (IDP->dwindow)->vbox), "Name", "?");
	IDP->value_entry = prompt_entry ((GTK_DIALOG (IDP->dwindow)->vbox), "Value", "1.0");
}
void instance_const (funs fp)
# define IDP ((instance_data *)fp->bp->idata)
{
	IDP = calloc (1, sizeof (instance_data));  /* create the data area */
	IDP->fp = fp; /* link to function */
{
}

	setup_const_dialog (fp->bp);
}

void remove_const (funs fp)
# define IDP ((instance_data *)fp->bp->idata)
{
{
}

	free (IDP);
	delete_box (fp->bp);
	redraw_request ("Constant destroyed");
}

void popup_delete_const (GtkWidget* w, boxp bp)
# define IDP ((instance_data *)bp->idata)
{
	remove_const (bp->fp);
}
void popup_adjust_const (GtkWidget* w, boxp bp)
# define IDP ((instance_data *)bp->idata)
{
{
}

	setup_const_dialog (bp);
}

void popup_const (boxp bp)
{
int item_count, i;
static GtkItemFactoryEntry popup_items[] = {
	{ "/Constant",			NULL,		NULL,					0,	"<Item>" },
	{ "/",				NULL,		NULL,					0,	"<Separator>" },
	{ "/Modify",		NULL,		popup_adjust_const,	0,	"<Item>" },	
	{ "/Delete",		NULL,		popup_delete_const,	0,	"<Item>" },
	{ "/Force update",  NULL,		force_update,			0,	"<Item>" },

	};  
	item_count =  sizeof (popup_items) / sizeof (popup_items[0]);
	for (i=0; i<item_count; i++) /* copy in the parameter */
		popup_items[i].callback_action = (guint) bp;


	popup_box (popup_items, bp->x, bp->y, item_count);	
}

void create_const (xmlNodePtr node, funs fp)
# define IDP ((instance_data *)fp->bp->idata)
{
	IDP = calloc (1, sizeof (instance_data));  /* create the data area */
	IDP->fp = fp; /* link to function */
	strncpy (IDP->text2, xmlGetProp (node, "name"), sizeof(IDP->text2));
	strncpy (IDP->text3, xmlGetProp (node, "value"), sizeof(IDP->text3));
	make_const (fp->bp);
}
void write_const (xmlNodePtr node, boxp bp)
# define IDP ((instance_data *)bp->idata)
{
	xmlSetProp(node, "name", IDP->text2);
	xmlSetProp(node, "value", IDP->text3);
}
