/*
 *  The graphical definition element of deltaFSD
 *  fcounter.c - the various components of the counter function 
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */    
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */

# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include "function.h"
# include "main.h"
# include "deletion.h"
# include "engine.h"

struct Fx counter_functions =
	{
	NULL,		// when the type of function is created
	instance_counter,	// create instance from UI
	NULL,		// called on right click
	create_counter,		// create instance from file
	NULL,		// genrate text version of configuration
	NULL, 		// any per instance clean up 
	"This implements an up/down counter\n"	// the descriptive text	
	"The first input increments/decrements the output\n"
	"The second input determines the direction zero - down, non-zero - up\n"
	"The third input resets the counter (when zero)"
};

typedef struct {
	GtkWidget *dwindow; /* the setup dialog box window */
	double prev_c;
	funs fp;
} count_data;


/* counter input function */
void Counter (funs fp)
{
	if ((In(0) && ((count_data *)fp->bp->idata)->prev_c)
		|| (!In(0) && !((count_data *)fp->bp->idata)->prev_c)) return;
	((count_data *)fp->bp->idata)->prev_c = In(0);
	if (In(0)) Out(0) = In(1) ? Out(0) + 1.0 : Out(0) - 1.0;
	if (!In(2)) Out(0) = 0.0;
}

void counter_button_press (count_data* cdp)
{ /* set up dialog callback */
	gtk_widget_destroy (cdp->dwindow);
}

void setup_counter_dialog (count_data* cdp)
{
	cdp->dwindow = create_entry_vbox (counter_button_press, (GtkObject*)cdp);/* cast ?? */
// add the caption
	text_info ((GTK_DIALOG (cdp->dwindow)->vbox), cdp->fp->funct->funcext->describe);
// the vbox of the dialogue contains no prompt entry pairs
}

void instance_counter (funs f)
{
count_data* cdp;
	cdp = malloc (sizeof (*cdp));  /* create the data area */
	cdp->fp = f;
	f->bp->idata = cdp;
	setup_counter_dialog (cdp);
	cdp->prev_c = 0.0;
}

void create_counter (xmlNodePtr node, funs f)
{
count_data* cdp;
	cdp = malloc (sizeof (*cdp));  /* create the data area */
	cdp->fp = f;
	f->bp->idata = cdp;
//	
	cdp->prev_c = 0.0;
}

