/*
 *  The graphical definition element of deltaFSD
 *  fileops.h - header file for fileops.c - read/write data files 
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */    
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */


#ifndef _FMISC_H_
#define _FMISC_H_
# include <gtk/gtk.h> 
# include "engine.h"

void line_popup (linp lp, gdouble x, gdouble y);
void popup_box (GtkItemFactoryEntry *popup_items, guint winx, guint winy, int nitems);
void popup_delete_box (GtkWidget* w, boxp bp);
void popup_delete_line (GtkWidget *w, linp lp);
void standard_popup (boxp bp);
GtkWidget *create_entry_vbox (GtkSignalFunc callback, GtkObject *cdp);
GtkWidget *prompt_entry (GtkWidget *vbox, char *prompt, char *dfault);
GtkWidget *file_select (GtkSignalFunc func, gpointer func_data);
void warning_box (char *text);
void force_update (GtkWidget* w, boxp bp);
void update_and_redraw (funs fp);
void text_info (GtkWidget *vbox, char *prompt);
void get_main_menu(GtkWindow *window, GtkWidget **menubar);


// macros to ensure a uniform look
# define STD_PACK(x,y) 	gtk_box_pack_start ((x), (y), FALSE, FALSE, 3);
# define STD_HBOX gtk_hbox_new (TRUE, 3)
# define STD_VBOX gtk_vbox_new (TRUE, 3)


#endif /* _FMISC_H_ */

