/*
 *  The graphical definition element of deltaFSD
 *  fprint.c - the various components of the print function 
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */    
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */

# include <stdlib.h>
# include <stdio.h>
# include <string.h>
# include "function.h"
# include "main.h" /* for mmode */
# include "gutils.h" /* for bpstart */

struct Fx print_functions =
	{
	NULL,		// when the type of function is created
	instance_print,	// create instance from UI
	NULL,		// called on right click
	create_print,	// create instance from file
	write_print,	// genrate text version of configuration
	NULL,		 // any per instance clean up 
	"Print boxes display the value of their input"	// the descriptive text
};

typedef struct {
	GtkWidget *dwindow;
	GtkWidget *name_entry;
	funs fp;
} print_data;


/* Print output */
void Print (funs fp) { snprintf (fp->bp->text2, BUFFER_SIZE, "= %.4f", In(0)); }

void print_button_press (print_data* pdp)
{
gchar *entry_text;
// extract the name to text field 1
	pdp->fp->bp->text1 = malloc(BUFFER_SIZE); /* will hold the name */
	entry_text = gtk_entry_get_text(GTK_ENTRY(pdp->name_entry));
	strncpy (pdp->fp->bp->text1, entry_text, BUFFER_SIZE);
//
	gtk_widget_destroy (pdp->dwindow); /* done with the setup window */
//
	pdp->fp->bp->text2 = malloc(BUFFER_SIZE); /* will hold the value */
	pdp->fp->bp->text2[0] = 0; /* nothing yet */
}	

void setup_print_dialog (print_data* pdp)
{
	pdp->dwindow = create_entry_vbox (print_button_press, (GtkObject*)pdp);/* fix cast ?? */
// add the caption
	text_info ((GTK_DIALOG (pdp->dwindow)->vbox), pdp->fp->funct->funcext->describe);
// the vbox of the dialogue contains one prompt entry pair
	pdp->name_entry = prompt_entry ((GTK_DIALOG (pdp->dwindow)->vbox), "Name", "?");
}

void instance_print (funs f)
{
print_data* pdp;
	pdp = malloc (sizeof (*pdp));  /* create the data area */
	pdp->fp = f;
	setup_print_dialog (pdp);
}

void create_print (xmlNodePtr node, funs f)
{
print_data* pdp;
	pdp = malloc (sizeof (*pdp));  /* create the data area */
	pdp->fp = f;

	f->bp->text1 = malloc(BUFFER_SIZE); /* will hold the name */
	strncpy (f->bp->text1, xmlGetProp (node, "name"), BUFFER_SIZE);
//
	f->bp->text2 = malloc(BUFFER_SIZE); /* will hold the value */
	f->bp->text2[0] = 0; /* nothing yet */
}	

void write_print (xmlNodePtr node, boxp bp)
{
	xmlSetProp(node, "name", bp->text1); 
}
	
