/*
 *  The graphical definition element of deltaFSD
 *  function.h - header file all of the function definition files 
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */    
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */



#ifndef _FUNCTION_H_
#define _FUNCTION_H_

# include <gtk/gtk.h>
# include <gnome-xml/tree.h>
# include "gutils.h"
# include "engine.h"
# include "fileops.h"
# include "fmisc.h"

# define In(n) (((fp->frstin[n]).ovarb)?((fp->frstin[n]).ovarb->current_value):0)
# define Out(n) (fp->frstout[n]).next_value

// this rather awkward macro is a temporary fix whilst we decide what to do about strobed functions
# define Strobe(n) static float t; if (t == In(n)) return; t = In(n); 


/* the menu and registration protoypes */
void register_functions ();

extern struct Ft functions [];

extern struct Fx timer_functions;
void Timer (funs f);

extern struct Fx ticker_functions;
void Ticker (funs f);

extern struct Fx counter_functions;
void Counter (funs f);
void instance_counter (funs f);
void create_counter (xmlNodePtr node, funs f);

extern struct Fx get_functions;
void Get (funs f);

extern struct Fx graph_functions;
void Graph (funs f);

extern struct Fx chart_functions;
void Chart (funs f);

extern struct Fx print_functions;
void Print (funs f);
void instance_print (funs f);
void create_print (xmlNodePtr node, funs f);
void write_print (xmlNodePtr node, boxp bp);

extern struct Fx module_functions;
void Module (funs f);

extern struct Fx perl_functions;
void Perl (funs f);

extern struct Fx socket_functions;
void Socket (funs f);

extern struct Fx const_functions;
void Constant (funs f);

extern struct Fx trackhold_functions;
void TrackHold (funs f);
void instance_trackhold (funs f);

extern struct Fx edgesample_functions;
void EdgeSample (funs f);
void instance_edgesample (funs f);

extern struct Fx filter_functions;
void Filter (funs f);
void instance_filter (funs f);
void create_filter (xmlNodePtr node, funs f);
void write_filter (xmlNodePtr node, boxp bp);



#endif /* _FUNCTION_H_ */
