/*
 *  The graphical definition element of deltaFSD
 *  main.h - header file for main.c - overall program start-up and initialization 
 *	Copyright (C) 2003, 2004 DeDf, 45 Belper Road, Derby, DE1 3EP, UK
 */	
/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 *  The deltaFSD concept was developed by DeDf:
 *
 *		deltafsd@dedf.co.uk
 *
 *		www.dedf.co.uk/deltafsd
 *
 *		DeDf
 *		45 Belper Road
 *		Derby
 *		DE1 3EP
 *		UK
 *
 *		+44 1332 381481
 *
 */



# ifndef _MAIN_H_
# define _MAIN_H_

# define VERSION "0.4"
# define VERSION_STRING " This is version " VERSION " of deltaFSD \n(c) 2003, 2004 DeDf\n www.dedf.co.uk/deltafsd\n"

# define BUFFER_SIZE 30
# define PATH_BUFFER_SIZE 130
typedef char std_buffer[BUFFER_SIZE];
typedef char path_buffer[PATH_BUFFER_SIZE];

# include <gtk/gtk.h>
# include "gutils.h"
# include "engine.h"


typedef enum { NOTHING, BOX, LINE, SEGMENT, SRCSTUB, DSTSTUB, XSEGMENT, YSEGMENT } Object_type;
struct current_select
{
	Object_type typ;
	void *objct;
};
extern struct current_select cursel;

typedef enum { SELECT, MOVE, NEWBOX, NEWLINE, NEWSEG, FILEREAD } Operation_type;
extern Operation_type mmode;


gint configure_event( GtkWidget *widget, GdkEventConfigure *event );
gint expose_event( GtkWidget *widget, GdkEventExpose *event );
void select_obj ( GtkWidget *widget, GdkEventButton *event );
void select_event ( GtkWidget *widget, GdkEventButton *event );
void delete_event ( GtkWidget *widget, GdkEventButton *event );
gint button_press_event( GtkWidget *widget, GdkEventButton *event );
gint button_release_event( GtkWidget *widget, GdkEventButton *event );
gint motion_notify_event( GtkWidget *widget, GdkEventMotion *event );
void quit ();
void add_menu_item (gchar *path, gchar *accelerator, GtkItemFactoryCallback callback, guint callback_action,		gchar *item_type);
void user_insert (char *fname, funcp func, funcp regstr, funcp init, int ins, int outs);
void create_finst (GtkWidget* w, futs fp);


//# define DUMP // define for text output dump - see redraw_request() in gutils.c
# define DISPLAY_UPDATE_RATE 100  // define for limited redraw - see redraw_request() in gutils.c

# define MAX_BOXES_PER_FILE 200 // needs fix

#endif /* _MAIN_H_ */
