package Radios;

use base qw/Tk::Derived Tk::Canvas/;

Construct Tk::Widget 'Radios';


sub Populate
{
    my($self, $args) = @_;
	$self->SUPER::Populate($args);

    $self->ConfigSpecs(
        -numb_radios  	=> ['PASSIVE',	'numb_radios',	'numb_radios',	4],
		-rprompts     	=> ['PASSIVE',	'rprompts',		'rprompts',		['A', 'B', 'C', 'D']],
        -rvalues		=> ['PASSIVE',	'rvalues',		'rvalues',		[1,2,3,4]],
        -font 			=> ['PASSIVE',	'font',			'Font',			'Courier 8'],
		-command		=> ['PASSIVE',	'command',		'Command', 		undef],
        -variable		=> ['PASSIVE',	'variable',		'variable',		undef],
        -width 			=> ['SELF',		'width',		'Width',		200],
        -height			=> ['SELF',		'height',		'Height',		230],
        -relief			=> ['SELF',		'relief',		'Relief',		'sunken'],
        -borderwidth	=> ['SELF',		'borderwidth',	'Borderwidth',	2],
    );    
}

sub new 
{ # we need to access the set or default values - new() is the first place they are set 
my ($class,$widget,%args) = @_;
my $obj = $class->SUPER::new($widget,%args);

my $numb_radios = $obj->cget(-numb_radios);
my $rprompts = $obj->cget(-rprompts);
my $rvalues = $obj->cget(-rvalues);
my $variable = $obj->cget(-variable);
my $command = $obj->cget(-command);

my $cols;
for (my ($i); $i < $numb_radios; $i++)
	{
	$obj->Radiobutton(-text => $$rprompts[$i], -value => $$rvalues[$i], 
		-variable => $variable,	-command => $command)
		->grid(-row =>int($i/4), -column => int($i%4), -sticky => "nsew", -padx=>5, -pady=>10);
	}
	return ($obj);
}

1;