
package Slider;

use base qw/Tk::Derived Tk::Scale/;

Construct Tk::Widget 'Slider';

sub Populate
{
    my($self, $args) = @_;
	$self->SUPER::Populate($args);

    $self->ConfigSpecs(
        -pad_to			=> ['PASSIVE',	'pad_to',		'Pad_to',		17],
        -font			=> ['SELF',		'font',			'Font',			'Courier 8'],
        -resolution		=> ['SELF',		'resolution',	'Resolution',	0.01],
        -from			=> ['SELF',		'from',			'From',			0.00],
        -to				=> ['SELF',		'to',			'To',			1.00],
        -orient			=> ['SELF',		'orient',	'orient',	'vertical'],
        -width 			=> ['SELF',		'width',		'Width',		13],
        -length			=> ['SELF',		'length',		'Length',		130],
        -sliderlength	=> ['SELF',		'sliderlength',	'Sliderength',	20],
        -label			=> ['SELF',		'label',		'Label',		'A slider'],
        -relief			=> ['SELF',		'relief',		'Relief',		'sunken'],
        -borderwidth	=> ['SELF',		'borderwidth',	'Borderwidth',	2],
    );    
}

sub new 
{ # we need to access the set or default values - new() is the first place they are set 
my ($class,$widget,%args) = @_;
my $obj = $class->SUPER::new($widget,%args);
my $pad_to = $obj->cget(-pad_to);
my $label = $obj->cget(-label);

	while (length ($label) < $pad_to) { $label = $label . ' '; }
	$obj->configure(-label=>$label);
	return ($obj);
}
1;