#!/usr/bin/perl

use IO;
use Tk;

require Slider;
require Radios;
require Meter;
require LCD;

$H = 0;
@o = (0,0,0); # the output data array
@i = (0,0,0); # the input data array

sub testit
{ # called when the pipe has some data to read
	$stat = sysread $H, $buf, 4096;
	while ($buf)
		{ # tease out the channel value, comma seperated pairs
		$buf =~ /,*([-\d\.]+?),(.*)/;
		$chan = $1; # strip out the channel number
		$buf = $2;	# and recover the rest of the buffer
		$buf =~ /,*([-\d\.]+?),(.*)/;
		$val = $1;	# strip out the value
		$buf = $2;	# and recover the rest of the buffer
		$i[$chan] = $val; # set this value
		} # and loop for the next channel,value pair
}

sub setit
{ # called when a data source has a changed value to send
my ($chan, $val) = @_;
	print $H "$chan,$val"; # just send it down the pipe 
}


my $mw = MainWindow->new;

$mw->title("TkPanel");
$mw->Meter(-label=>'Power', -variable=>\$i[0])->grid(-row=>1, -column=>2);
$mw->LCD(-variable=>\$i[1])->grid(-row=>2, -column=>2);
$mw->Slider(-variable=>\$o[0], -command=>sub { setit 0, $o[0] }, -label=>"Voltage")->grid(-row=>1, -column=>1);
$mw->Slider(-variable=>\$o[1], -command=>sub { setit 1, $o[1] }, -label=>"Current")->grid( -row=>2, -column=>1, -rowspan=>2);
$mw->Radios(-variable=>\$o[2], -command=>sub { setit 2, $o[2] },  -numb_radios=>3, -rvalues=>[1,2,5], -rprompts=>['x1','x2','x5'])->grid(-row=>3, -column=>2);

$H = new IO::Socket::INET (PeerAddr => 'edfmserve', PeerPort => 6739, Proto => 'tcp');
die "Socket could not be created. Reason: $!\n" unless $H;

$mw->fileevent(\*$H, 'readable', [\&testit, $t]); # callback when data is available from deltaFSD 

MainLoop;


